# Deploy

This section will show you how to deploy your project on different environments.

## Deploy build to builds branches

3 builds branch are today available for Ecolyo:

- **build**: reflect the build of the master branch and the version deployed in production environment
- **build-dev**: reflect the build of the dev branch and the version deployed on dev environment
- **build-test**: reflect a temporary build which can be used for test purpose

!!! info "Windows users"
    Some command did not run on Windows. Please use your Linux distribution installed on your WSL. For more information about it see the [Install WSL section](../getting_started/setup_your_environment.md)

Make sure that:  

- you are on the right branch (dev or master) depending on the environment you need to deploy.
- your branch is up to date
- you node modules are up to date

First build the application :
```
$ yarn build
```

Next you can deploy the build to the target branch:
```
# deploy on build-test branch
$ yarn deploy-test
# deploy on build-dev branch
$ yarn deploy-dev
# deploy on build branch
$ yarn deploy
```

## Auto deploy for dev

In order to prevent manual action for deployment, a gitlab-runner has been configured to deploy every changes on the `dev` branch on our test [env](https://ecolyo.ecolyodemo.cozy.self-data.alpha.grandlyon.com/)

!!! info "cicd scripts"
    You can find all scripts used in cicd jobs on the following [repository](https://forge.grandlyon.com/web-et-numerique/llle_project/ecolyo-infra-scripts)

## Deploy build-test branch to one Scaleway instance for testing

You can directly use the content of build-test branch to update one instance for test purpose.
Simply use the dedicated script `update_ecolyo_test.sh <instance_name>` with the targeted instance (from the server).
By default we use the ecolyotest instance for testing intermediate functionality.
For more information you can check for [Easy Cozy scripts](../../../easycozy/commands/).

## Deploy build-dev branch to all Scaleway instances

You can directly use the content of build-dev branch to update apps on dev environment using scripts (from the server).
Simply use the dedicated script `update_all_ecolyo_dev.sh` (from the server).
For more information you can check for [Easy Cozy scripts](../../../easycozy/commands/).

## Deploy build branch to Cozy

You can deploy content of build branch into Cozy registry by using the cozy-app-publish command after replacing following value:

- $REGISTRY_TOKEN : token provided by Cozy team
- $VERSION_NUMBER: version of the application
- $COZY_SPACE: space of the Cozy 

```sh
$ yarn cozy-app-publish \
--token $REGISTRY_TOKEN \
--build-url https://forge.grandlyon.com/web-et-numerique/llle_project/ecolyo/-/archive/build/ecolyo-build.tar.gz \
--manual-version $VERSION_NUMBER \
--space $COZY_SPACE
```

More information at [cozy-app-publish](https://docs.cozy.io/en/cozy-app-publish)
